# oidc_core

[![style: very good analysis][very_good_analysis_badge]][very_good_analysis_link]
[![License: MIT][license_badge]][license_link]
[![codecov][coverage_badge]][coverage_link]
[![Pub Version][pub_badge]][pub_link]

An [OpenId Connect RP (Relying Party)][spec_link] package for dart, which exposes basic models and functionality defined by the OIDC standard.

Make sure you read the [![Wiki](https://img.shields.io/badge/wiki-purple)](https://bdaya-dev.github.io/oidc_core/) for how to use this package.

## Introduction

This package only requires dart, and can be used in all platforms.

Since the `OIDC` specification requires interactions with the underlying platform (e.g. launching a browser, listening for redirect, etc...), this package can't be used by it self to implement the spec.

The full spec is implemented in [package:oidc](https://github.com/Bdaya-Dev/oidc/tree/main/packages/oidc) which depends on flutter.

## Installation 💻

**❗ In order to start using this package you must have the [Dart SDK][dart_install_link] installed on your machine.**

Add to your `pubspec.yaml`:

```sh
dart pub add oidc_core
```

## Running Tests 🧪

To run all unit tests:

```sh
dart pub global activate coverage 1.2.0
dart test --coverage=coverage
dart pub global run coverage:format_coverage --lcov --in=coverage --out=coverage/lcov.info
```

To view the generated coverage report you can use [lcov](https://github.com/linux-test-project/lcov).

```sh
# Generate Coverage Report
genhtml coverage/lcov.info -o coverage/

# Open Coverage Report
open coverage/index.html
```

---

Generated by the [Very Good CLI][very_good_cli_link] 🤖

[spec_link]: https://openid.net/wg/connect/specifications/
[coverage_link]: https://codecov.io/github/Bdaya-Dev/oidc
[coverage_badge]: https://codecov.io/github/Bdaya-Dev/oidc/graph/badge.svg?token=HSEDM6I7TH
[dart_install_link]: https://dart.dev/get-dart
[pub_badge]: https://img.shields.io/pub/v/oidc_core
[pub_link]: https://pub.dev/packages/oidc_core
[license_badge]: https://img.shields.io/badge/license-MIT-blue.svg
[license_link]: https://opensource.org/licenses/MIT
[very_good_analysis_badge]: https://img.shields.io/badge/style-very_good_analysis-B22C89.svg
[very_good_analysis_link]: https://pub.dev/packages/very_good_analysis
[very_good_cli_link]: https://github.com/VeryGoodOpenSource/very_good_cli


